function subtitulos_init() {

	this.get_title = function() {
		return "Buscar/reparar subtítulos";
	}

	this.run = function (ret_obj) {

		if (ret_obj != undefined) {
			this.ret_obj = ret_obj;
		}
		mostrar_elemento("contenidos");
		window.cb_teclado = this;
		this.selector = new seleccionar_fichero("",["sub", "srt", "avi", "mkv", "ts", "mp4", "mp4v", "asf", "divx", "dvx", "h264", "mpg", "mpg2", "mpg4", "mpeg", "mpeg2", "mpeg4", "mov", "mp2v", "vc1", "wmv"]);
		this.show_titulo();
		document.getElementById("c_teclas").innerHTML = '<p class="teclas_entry"><img src="left.png"/>Carpeta anterior &nbsp;&nbsp;&nbsp; <img src="ok.png"/>Buscar &nbsp;&nbsp;&nbsp; <img src="return.png"/> Volver</p>';
		this.refrescar();
	}

	this.refrescar = function() {
		if (this.selector.refrescar_lista_ficheros()) {
			this.show_error();
		}
	}

	this.show_error = function() {
		var w = new popup_window(this.ret_obj,"No se ha podido obtener la lista de ficheros",true);
	}

	this.show_titulo = function() {
		document.getElementById("c_titulo").innerHTML = '<p class="titulo_entry_subt">Subtitulos ('+this.selector.carpeta+')</p>';
		ajustar_tamanos();
	}

	this.keycb = function (e) {
		switch (e) {
		case HED.KC_RETURN: ///< RETURN (ESCAPE)
			this.ret_obj.run();
		break;
		case HED.KC_UP:
			this.selector.anterior(false);
		break;
		case HED.KC_DOWN:
			this.selector.siguiente(false);
		break;
		case HED.KC_RED:
			this.selector.anterior(true);
		break;
		case HED.KC_BLUE:
			this.selector.siguiente(true);
		break;
		case HED.KC_LEFT:
			this.selector.subir_carpeta();
			this.show_titulo();
			this.selector.refrescar_lista_ficheros();
		break;
		case HED.KC_ENTER:
			var retval = this.selector.seleccion();
			if (retval == undefined) {
				this.show_titulo();
				if (this.selector.refrescar_lista_ficheros()) {
					this.show_error();
				}
				return;
			}
			var obj = this;
			try {
				HED.configuration.get_key("bittorrent_subtitulos",
					function(valor) {
						var lengua = valor[0].value;
						if ((lengua == undefined) || (lengua == "")) {
							lengua = "es";
						}
						obj.do_popup_subtitulos(obj,retval,lengua);
					},
					function(v2) {
						var lengua="es";
						obj.do_popup_subtitulos(obj,retval,lengua);
					}
				);
			} catch (v) {
				obj.do_popup_subtitulos(obj,retval,"es");
			}
		break;
		}
	}

	this.do_popup_subtitulos = function(objeto,fichero, lengua) {

		objeto.lang_popup = new popup_window(objeto,'<p class="popup_contenido">¿Lengua para subtitulos? (es: español; en: ingles; pt: portugues...)</p><p class="popup_contenido"><div id="write_here"></div></p>','<p class="teclas_entry"><img src="return.png" />&nbsp;Cancelar&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="ok.png" />&nbsp;Siguiente</p>');

		var my_input = HED.widgets.input_text({
			parent: $('#write_here'),
			type: 'text',
			initText: lengua,
			defaultEnabled: true,
			oStyle: {'width': ((window.width/2)-40).toString()+"px", 'height': '30px', 'align' : 'center'},
			fCallback: {
				select: function(oEvent, lengua2) {
					if (oEvent.keyCode==HED.KC_RETURN) {
						objeto.lang_popup.ocultar();
					} else {
						if (lengua2!="") {
							try {
								HED.configuration.set_key("bittorrent_subtitulos",lengua2,function() {}, function() {});
							} catch (v) {
							}
							objeto.do_popup_subtitulos2(fichero,lengua2);
						}
					}
				}
			},
			kc : {
				undo: [],
				enable : [],
				disable: [],
				select: [HED.KC_ENTER, HED.KC_RETURN]
			}
		});
		$('#write_here a:first').focus();
	}

	this.do_popup_subtitulos2 = function(fichero, lengua) {

		this.lang_popup.ocultar();
		var pos = fichero.lastIndexOf(".");
		if (pos != -1) {
			var ext = fichero.substr(pos+1);
			if ((ext == "srt") || (ext == "sub")) {
				this.repara_subt(0,[this, fichero]);
				return;
			}
		}
		var cmd = new lanzar_comando('submarine -f "'+fichero+'" -l '+lengua,true);
		cmd.esperar_fin(this,"Buscando subtitulos",true,this.repara_subt,[this,fichero]);
	}

	this.repara_subt = function(retval,datos) {

		var objeto  = datos[0];
		var fichero = datos[1];

		if (retval.retval != 0) {
			var err_popup = new popup_window(objeto,"No se encontraron subtítulos para ese vídeo",true);
			return;
		}

		var cmd = new lanzar_comando('fixsubs "'+fichero+'"',false);
		cmd.esperar_fin(objeto,"Reparando subtitulos",false,objeto.fin,objeto);
	}

	this.fin = function(retval,objeto) {
		objeto.refrescar();
	}
}
